<?php
/**
 * 
 * @since 0.9
 */
$gltr_ua = array(
"Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.4; en-US; rv:1.9b5)",
"Mozilla/5.0 (Macintosh; U; PPC Mac OS X Mach-O; en-US; rv:1.0.1)",
"Mozilla/5.0 (Macintosh; U; PPC Mac OS X Mach-O; en-US; rv:1.0.1)",
"Mozilla/5.0 (Macintosh; U; PPC Mac OS X; en-US)",
"Mozilla/5.0 (Macintosh; U; PPC Mac OS X; en-us)",
"Mozilla/5.0 (Macintosh; U; PPC; en-US; rv:0.9.2)",
"Mozilla/5.0 (Windows; U; Win98; en-US; rv:0.9.2)",
"Mozilla/5.0 (Windows; U; Win98; en-US; rv:x.xx)",
"Mozilla/5.0 (Windows; U; Win9x; en; Stable)",
"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.5)",
"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:x.x.x)",
"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:x.xx)",
"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:x.xxx)",
"Mozilla/5.0 (Windows; U; Windows NT 6.0; en-US; rv:1.9b5)",
"Mozilla/5.0 (Windows; U;XMPP Tiscali Communicator v.10.0.1; Windows NT 5.1; it; rv:1.8.1.3)",
"Mozilla/5.0 (X11; Linux i686; U;rv: 1.7.13)",
"Mozilla/5.0 (X11; U; Linux 2.4.2-2 i586; en-US; m18)",
"Mozilla/5.0 (X11; U; Linux i686; en-GB; rv:1.7.6)",
"Mozilla/5.0 (X11; U; Linux i686; en-US; Nautilus/1.0Final)",
"Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.3)",
"Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.2b)",
"Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.6)",
"Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.0.7)",
"Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1)",
"Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.1)",
"Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9a8)",
);

/**
 * 
 * @since 0.9
 */
if (!function_exists('file_get_contents')) {
	function file_get_contents($filename, $incpath = false, $resource_context = null) {
		if (false === $handle = fopen($filename, 'rb', $incpath)) {
			return false;
		}
		if ($fsize = @filesize($filename)) {
			$buf = fread($handle, $fsize);
		} else {
			$buf = '';
			while (!feof($handle)) {
				$buf .= fread($handle, 8192);
			}
		}
		fclose($handle);
		return $buf;
	}	
}

/**
 * 
 * @since 0.9
 */
if(!interface_exists("gltr_translation_status")) {
	class gltr_translation_status {
		
		var $_status;
		var $_last_connection_time;
		
		function gltr_translation_status() {
			$exists = get_option("gltr_translation_status");
			if($exists === false){ 
				add_option("gltr_translation_status","");
			}
			$this->save();
		}
		
		function save() {
			update_option("gltr_translation_status",$this);		
		}		

		function load() {
			$status = @get_option("gltr_translation_status");
			if(is_a($status,"gltr_translation_status")) return $status;
			else return null;	
		}
			
    function save_status($status){
    	$this->_status = $status;
    	$this->save();
    }

    function get_status(){
    	return $this->_status;
    }
		
    function save_last_connection_time($last_connection_time){
    	$this->_last_connection_time = $last_connection_time;
    	$this->save();
    }

    function get_last_connection_time(){
    	return $this->_last_connection_time;
    }
		

	}

}

/**
 * 
 * @since 0.9
 */
if(!interface_exists("gltr_translation_engine")) {
	class gltr_translation_engine {
		var $_name;

		var	$_base_url;

		var $_links_pattern;

		var $_links_replacement;

		var $_languages_matrix;

		var $_available_languages;

		function gltr_translation_engine(
			$name,
			$base_url,
			$links_pattern,
			$links_replacement,
			$languages_matrix,
			$available_languages) {
	      $this->set_name($name);
        $this->set_base_url($base_url);
        $this->set_links_pattern($links_pattern);
        $this->set_links_replacement($links_replacement);
        $this->set_languages_matrix($languages_matrix);
        $this->set_available_languages($available_languages);
		}

    function set_name($name){
    	$this->_name = (string)$name;
    }

		function set_base_url($base_url){
    	$this->_base_url = (string)$base_url;
    }

		function set_links_pattern($links_pattern){
    	$this->_links_pattern = (array)$links_pattern;
    }

		function set_links_replacement($links_replacement){
    	$this->_links_replacement = (string)$links_replacement;
    }

		function set_languages_matrix($languages_matrix){
    	$this->_languages_matrix = (array)$languages_matrix;
    }

		function set_available_languages($available_languages){
    	$this->_available_languages = (array)$available_languages;
    }

    function get_name(){
    	return $this->_name;
    }

		function get_base_url(){
    	return $this->_base_url;
    }

		function get_links_pattern(){
    	return $this->_links_pattern;
    }

		function get_links_replacement(){
    	return $this->_links_replacement;
    }

		function get_languages_matrix(){
    	return $this->_languages_matrix;
    }

		function get_available_languages(){
    	return $this->_available_languages;
    }

    function decode_lang_code($res)
    {
      if ($this->_name == 'promt') {
        if ($res == 'es') $res = 's';
        else if ($res == 'de') $res = 'g';
        else $res = substr($res, 0, 1);
      } else if ($this->_name == 'freetransl') {
        $map = array(
      	  'en'    => 'English',
      	  'es'    => 'Spanish',
      	  'fr'    => 'French',
      	  'de'    => 'German',
      	  'it'    => 'Italian',
      	  'nl'    => 'Dutch',
      	  'pt'    => 'Portuguese',
      	  'no'    => 'Norwegian');
     	  $res = $map[$res];
      }
      return $res;
    }
    
    function build_clean_link($matches){
    	$res = "href=";
    	foreach($this->_match_id as $key=>$val){
    		
    	}
			return urldecode();
		}

	}
}

//Inlcude google settings file
require_once (dirname(__file__).'/google.php');

$well_known_extensions =  
    array('swf','gif','jpg','jpeg','bmp','gz','zip','rar','tar','png','xls',
    'doc','ppt','tiff','avi','mpeg','mp3','mov','mp4','c','sh','bat');
$gltr_available_engines = array();
$gltr_available_engines['google'] = $googleEngine;

//Just incase options are missing
add_option('gltr_base_lang', 'en');
add_option('gltr_col_num', '0');
add_option('gltr_html_bar_tag', 'TABLE');
add_option('gltr_my_translation_engine', 'google');
add_option('gltr_preferred_languages', array());
add_option('gltr_ban_prevention', true);
add_option('gltr_enable_debug', false);
add_option('gltr_conn_interval',580);
add_option('gltr_sitemap_integration',false);
add_option("gltr_last_connection_time",0);
add_option("gltr_translation_status","unknown");
add_option("gltr_cache_expire_time",30);
add_option('btr_translate_template', true);

/**
 * 
 * @since 0.9
 */
if (function_exists('gzcompress')){
	add_option("gltr_compress_cache",false);
} else {
	add_option("gltr_compress_cache",false);
}

/**
 * 
 * @since 0.9
 */
if (!function_exists('str_ireplace')){
  function str_ireplace($search,$replace,$subject){
    $token = chr(1);
    $haystack = strtolower($subject);
    $needle = strtolower($search);
    while (($pos=strpos($haystack,$needle))!==FALSE){
      $subject = substr_replace($subject,$token,$pos,strlen($search));
      $haystack = substr_replace($haystack,$token,$pos,strlen($search));
    }
    $subject = str_replace($token,$replace,$subject);
    return $subject;
  }
} 

/**
 * Settings to be moved TODO
 * @since 0.9
 */
if( !defined('WP_CONTENT_DIR') ) define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
$gltr_cache_dir = WP_CONTENT_DIR . "/ben-translate-cache/current";
$gltr_stale_dir = WP_CONTENT_DIR . "/ben-translate-cache/stale";
$gltr_merged_image=dirname(__file__) . '/gltr_image_map.png';
$gltr_uri_index = array();


/**
 * Sets location of Flag icons
 * @since 0.9
 */
function gltr_get_flag_image_path($language) {
  return dirname(plugin_basename(__FILE__)) . '/images/flags/flag_' . $language . '.png';
}

/**
 * 
 * @since 0.9
 */
function gltr_get_flag_image_path_copy() {
  $path = strstr(realpath(dirname(__file__)), 'wp-content');
  $path = str_replace('\\', '/', $path);
  $path = str_replace('/core', '', $path);
  return get_settings('siteurl') . '/' . $path . '/images/ben.png';
}

/**
 * Gets flag URL
 * @since 0.9
 */
function gltr_get_flag_image($language) {
  //thanks neanton!
  $path = strstr(realpath(dirname(__file__)), 'wp-content');
  $path = str_replace('\\', '/', $path);
  $path = str_replace('/core', '', $path);
  return get_settings('siteurl') . '/' . $path . '/images/flags/flag_' . $language . '.png';
}

/**
 * Checks whether Google XML sitemap plugin is active
 * @since 0.9
 */
function gltr_sitemap_plugin_detected(){
	if (function_exists('get_plugins')){
		$all_plugins = get_plugins();
		foreach( (array)$all_plugins as $plugin_file => $plugin_data) {
			if ($plugin_file == 'google-sitemap-generator/sitemap.php'||$plugin_file == 'sitemap.php') return true;
		}
		return false;
	} else
		return true;
}

/**
 * Checks whether Global Translator is active
 * @since 0.9
 */
function btr_gltr_plugin_detected(){
	if (function_exists('get_plugins')){
		$all_plugins = get_plugins();
		foreach( (array)$all_plugins as $plugin_file => $plugin_data) {
			if ($plugin_file == 'global-translator/translator.php'||$plugin_file == 'translator.php') return true;
		}
		return false;
	} else
		return true;
}

/**
 * Creates Cache File
 * @since 0.9
 */
function gltr_create_file($datafile){
	$success = true;
	if (!file_exists($datafile)){
      if (($handle = @fopen($datafile, "wb")) === false) return false;
	    if ((@fwrite($handle, '')) === false) return false;
      @fclose($handle);
	} 
	return true;
}

/**
 * 
 * @since 0.9
 */
function gltr_translator_init() {
  global $wp_rewrite;
  if (isset($wp_rewrite) && $wp_rewrite->using_permalinks()) {
    define('REWRITEON', true);
    define('LINKBASE', $wp_rewrite->root);
  } else {
    define('REWRITEON', false);
    define('KEYWORDS_REWRITEON', '0');
    define('LINKBASE', '');
  }
  if (REWRITEON) {
    add_filter('generate_rewrite_rules', 'gltr_translations_rewrite');
  }
  
	if (isset($_GET['gltr_redir'])){
		$resource = urldecode($_GET['gltr_redir']);
		gltr_debug("gltr_translator_init :: found gltr_redir=$resource");
		gltr_make_server_redirect_page($resource);
	}
}

/**
 * Adds Translated pages to Google XML Plugin
 * @since 0.9
 */
function gltr_add_translated_pages_to_sitemap() {
	global $gltr_uri_index;
	$start= round(microtime(true),4);
	@set_time_limit(120);
  global $wpdb;
  if (SITEMAP_INTEGRATION == TRUE){
	 if (gltr_sitemap_plugin_detected()){
	 	 $generatorObject = &GoogleSitemapGenerator::GetInstance();
	   $posts = $wpdb->get_results("SELECT * FROM $wpdb->posts WHERE post_status = 'publish' AND post_password='' ORDER BY post_modified DESC");
      $chosen_langs = get_option('gltr_preferred_languages');
  	
  	//homepages
		foreach($chosen_langs as $lang){
			$trans_link = "";
			if (REWRITEON){
				$trans_link = preg_replace("/".BLOG_HOME_ESCAPED."/", BLOG_HOME . "/$lang/" , BLOG_HOME );
			} else {
				$trans_link = BLOG_HOME . "?lang=$lang";
			}
			if (gltr_is_cached($trans_link,$lang))
				$generatorObject->AddUrl($trans_link,time(),"daily",1);
		}
		
		//posts
    foreach($chosen_langs as $lang){
		foreach ($posts as $post) {
			$permalink = get_permalink($post->ID);			
				$trans_link = "";
				if (REWRITEON){
					$trans_link = preg_replace("/".BLOG_HOME_ESCAPED."/", BLOG_HOME . "/" . $lang, $permalink );
				} else {
					$trans_link = $permalink . "&lang=$lang";
				}
				if (gltr_is_cached($trans_link,$lang))
					$generatorObject->AddUrl($trans_link,time(),"weekly",0.2);
			}
			$gltr_uri_index[$lang] = array();//unset
		}
	}
  $end = round(microtime(true),4);
 	gltr_debug("Translated pages sitemap addition process total time:". ($end - $start) . " seconds");
	}
}

/**
 * 
 * @since 0.9
 */
function gltr_patch_translation_url($res) {	
  if (TRANSLATION_ENGINE == 'google'){
    $maincont = gltr_http_get_content($res);
    $matches = array();
    preg_match( '/(\/translate_p[^"]*)"/',$maincont,$matches);
    $res = "http://translate.google.com" . $matches[1];
    $res = str_replace('&amp;','&', $res);    
    gltr_debug("gltr_patch_translation_url :: Google Patched: $res");
  }
	return $res;
}

/**
 * 
 * @since 0.9
 */
function gltr_build_translation_url($srcLang, $destLang, $urlToTransl) {
  global $gltr_engine;
  $urlToTransl = urlencode($urlToTransl); 
  $tokens = array('${URL}', '${SRCLANG}', '${DESTLANG}'); 
  $srcLang = $gltr_engine->decode_lang_code($srcLang);  
  $destLang = $gltr_engine->decode_lang_code($destLang);
  $values = array($urlToTransl, $srcLang, $destLang); 
  $res = str_replace($tokens, $values, $gltr_engine->get_base_url());
  return $res;
} 

/**
 * 
 * @since 0.9
 */
function gltr_clean_url_to_translate(){
  $url = gltr_get_self_url();
  $url_to_translate = "";

  $blog_home_esc = BLOG_HOME_ESCAPED;

  if (REWRITEON) {
    $contains_index = (strpos($url, 'index.php')!==false);
    if ($contains_index){
      $blog_home_esc .= '\\/index.php';
    }
    $pattern1 = '/(' . $blog_home_esc . ')(\\/(' . LANGS_PATTERN . ')\\/)(.+)/';
    $pattern2 = '/(' . $blog_home_esc . ')\\/(' . LANGS_PATTERN . ')[\\/]{0,1}$/';

    if (preg_match($pattern1, $url)) {
      $url_to_translate = preg_replace($pattern1, '\\1/\\4', $url);
    } elseif (preg_match($pattern2, $url)) {
      $url_to_translate = preg_replace($pattern2, '\\1', $url);
    }
    gltr_debug("gltr_clean_url_to_translate :: [REWRITEON] self url:$url | url_to_translate:$url_to_translate");

  } else {
  
    $url_to_translate = preg_replace('/[\\?&]{0,1}lang\\=(' . LANGS_PATTERN . ')/i', '', $url);
    gltr_debug("gltr_clean_url_to_translate :: [REWRITEOFF] self url:$url | url_to_translate:$url_to_translate");
  }
  return $url_to_translate;
}

/**
 * Redirects page
 * redirects to google translate  
 * @since 0.9
 */
function gltr_make_server_redirect_page($resource){
	if (isset($_GET['gltr_redir'])){		
		$unavail =
			'<html>
        <head>
          <title>Translation not available</title>
			     <META NAME="ROBOTS" CONTENT="NOINDEX, NOFOLLOW">
			     <style>html,body {font-family: arial, verdana, sans-serif; font-size: 14px;margin-top:0px; margin-bottom:0px; height:100%;}</style>
        </head>
			   <body>
          <center>
            <br /><br />
            <b>
              This page has not been translated yet.
              <br /><br />
              The translation process could take a while: in the meantime a semi-automatic translation will be provided in a few seconds.
            </b>
            <br /><br />
            <b>
              or click <a href="{RESOURCE}">here</a> to redirect now.<br />
            </a>
            <a href="'.get_settings('home').'">Home page</a>
          </center>
			 <script type="text/javascript"><!--
			   setTimeout("Redirect()",5000);
			   function Redirect(){
			    location.href = "{RESOURCE}";
			   }
			   // -->
        </script>
      </body>
      </html>';
	  $message = str_replace('{RESOURCE}', $resource , $unavail);
	} else {
		$redirect = gltr_add_get_param(gltr_get_self_url(), 'gltr_redir', urlencode($resource));
		gltr_debug("gltr_make_server_redirect_page :: redirecting to $redirect");
		header("Location: $redirect", TRUE, 302);
		die();
  }
  return $message;
}

/**
 * 
 * @since 0.9
 */
function gltr_add_get_param($url,$param, $value){
  if (strpos($url,'?')===false)
    $url .= "?$param=$value";
  else
    $url .= "&$param=$value";
  return $url;
}

/**
 * 
 * @since 0.9
 */
function gltr_translate($lang) {
  global $gltr_engine;
  
  $page = "";
  $url_to_translate = gltr_clean_url_to_translate();
  $resource = gltr_build_translation_url(BASE_LANG, $lang, $url_to_translate);

  if (!gltr_is_connection_allowed()){
  	$page = gltr_make_server_redirect_page($resource);
  } else {
	  $buf = gltr_http_get_content(gltr_patch_translation_url($resource));
		if (gltr_is_valid_translated_content($buf)){
	  	gltr_store_translation_engine_status('working');
			$page = gltr_clean_translated_page($buf, $lang);
		} else {
	  	gltr_store_translation_engine_status('banned');
	  	gltr_debug("Bad translated content for url: $url_to_translate \n$buf");
	  	$page = gltr_make_server_redirect_page($resource);
	 	}
  }
  return $page;
}

/**
 * 
 * @since 0.9
 */
function gltr_http_get_content($resource) {
  $isredirect = true;
  $redirect = null;
	
	while ($isredirect) {
    $isredirect = false;
    if (isset($redirect_url)) {
      $resource = $redirect_url;
    }

    $url_parsed = parse_url($resource);
    $host = $url_parsed["host"];
    $port = $url_parsed["port"];
    if ($port == 0)
      $port = 80;
    $path = $url_parsed["path"];
    if (empty($path))
      $path = "/";
    $query = $url_parsed["query"];
    $http_q = $path . '?' . $query;

    $req = gltr_build_request($host, $http_q);
				
    $fp = @fsockopen($host, $port, $errno, $errstr);

    if (!$fp) {
      return "$errstr ($errno)<br />\n";
    } else {
      fputs($fp, $req, strlen($req)); // send request
      $buf = '';
      $isFlagBar = false;
      $flagBarWritten = false;
      $beginFound = false;
      $endFound = false;
      $inHeaders = true;
			$prevline='';
      while (!feof($fp)) {
        $line = fgets($fp);
        if ($inHeaders) {
        	
          if (trim($line) == '') {
            $inHeaders = false;
            continue;
          }

          $prevline = $line;
          if (!preg_match('/([^:]+):\\s*(.*)/', $line, $m)) {
            // Skip to the next header
            continue;
          } 
          $key = strtolower(trim($m[1]));
          $val = trim($m[2]);
					if ($key == 'location') {
            $redirect_url = $val;
          	$isredirect = true;
          	break;
          }
          continue;
        }
				
        $buf .= $line;
      } //end while
    }
    fclose($fp);
  } //while($isredirect) 
  return $buf; 
}

/**
 * 
 * @since 0.9
 */
function gltr_is_valid_translated_content($content){
	return (strpos($content, FLAG_BAR_BEGIN) > 0);
}

/**
 * 
 * @since 0.9
 */
function gltr_store_translation_engine_status($status){
	$exists = get_option("gltr_translation_status");
	if($exists === false){ 
		add_option("gltr_translation_status","unknown");
	}
	update_option("gltr_translation_status",$status);	
}

/**
 * 
 * @since 0.9
 */
function gltr_is_connection_allowed(){
	$last_connection_time = get_option("gltr_last_connection_time");
	if($last_connection_time === false){ 
		add_option("gltr_last_connection_time",0);
		$last_connection_time = 0;
	} 
	
	if ($last_connection_time > 0){
		$now = time();
		$delta = $now - $last_connection_time;
		if ($delta < CONN_INTERVAL){
			gltr_debug("gltr_is_connection_allowed :: Blocking connection request: delta=$delta secs");
			$res = false;
		} else {
			gltr_debug("gltr_is_connection_allowed :: Allowing connection request: delta=$delta secs");
			update_option("gltr_last_connection_time", $now);
	    $res = true;
	  }
	} else {
		gltr_debug("gltr_is_connection_allowed :: Warning: 'last_connection_time' is undefined: allowing translation");
		update_option("gltr_last_connection_time", time());
		$res = true;
	}
	return $res;
}

/**
 * 
 * @since 0.9
 */
function gltr_clean_link($matches){
  if (TRANSLATION_ENGINE == 'google'){
    $res = "=\"" . urldecode($matches[1]) . $matches[3] . "\"";
    if ($matches[4] == '>') $res .= ">";
  } else {
    $res = "=\"" . urldecode($matches[1]) . "\"";
  }
  return $res;
}

/**
 * 
 * @since 0.9
 */
function gltr_clean_translated_page($buf, $lang) {
  global $gltr_engine;
	global $well_known_extensions;  
	$is_IIS = (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS') !== false) ? true : false;

	$patterns = $gltr_engine->get_links_pattern();
	foreach( $patterns as $id => $pattern){
  	$buf = preg_replace_callback($pattern, "gltr_clean_link", $buf);
  }
	
  $buf = preg_replace("/<meta name=\"description\"([ ]*)content=\"([^>]*)\"([ ]*)\/>/i", "", $buf);
  $buf = preg_replace("/<meta name='description'([ ]*)content='([^>]*)'([ ]*)\/>/i", "", $buf);
	//TODO: add <meta name="language" content="LANG" />


  $blog_home_esc = BLOG_HOME_ESCAPED;
  $blog_home = BLOG_HOME;

  if (REWRITEON) {
    if ($is_IIS){
      $blog_home_esc .= '\\/index.php';
      $blog_home .= '/index.php';
      $pattern = "/<a([^>]*)href=\"" . $blog_home_esc . "(((?![\"])(?!\/trackback)(?!\/feed)" . gltr_get_extensions_skip_pattern() . ".)*)\"([^>]*)>/i";
      $repl = "<a\\1href=\"" . $blog_home . '/' . $lang . "\\2\" \\4>";
      //gltr_debug("IS-IIS".$repl."|".$pattern);
      $buf = preg_replace($pattern, $repl, $buf);
    } else {
      $pattern = "/<a([^>]*)href=\"" . $blog_home_esc . "(((?![\"])(?!\/trackback)(?!\/feed)" . gltr_get_extensions_skip_pattern() . ".)*)\"([^>]*)>/i";
      $repl = "<a\\1href=\"" . $blog_home . '/' . $lang . "\\2\" \\4>";
      //gltr_debug($repl."|".$pattern);
      $buf = preg_replace($pattern, $repl, $buf);
    }
  } else {
    $pattern = "/<a([^>]*)href=\"" . $blog_home_esc . "\/\?(((?![\"])(?!\/trackback)(?!\/feed)" . gltr_get_extensions_skip_pattern() . ".)*)\"([^>]*)>/i";
    $repl = "<a\\1href=\"" . $blog_home . "?\\2&lang=$lang\" \\4>";
    $buf = preg_replace($pattern, $repl, $buf);
    
    $pattern = "/<a([^>]*)href=\"" . $blog_home_esc . "[\/]{0,1}\"([^>]*)>/i";
    $repl = "<a\\1href=\"" . $blog_home . "?lang=$lang\" \\2>";
    $buf = preg_replace($pattern, $repl, $buf);
  }

  //let's remove custom tags added by certain engines
  if (TRANSLATION_ENGINE == 'promt') {
    //$buf = preg_replace("/\<div class='PROMT_HEADER'(.*)\<\/div\>/i", "", $buf);
    //$buf = preg_replace("/\<span class=\"UNKNOWN_WORD\"\>([^\<]*)\<\/span\>/i", "\\1",$buf);
    $buf = preg_replace("/onmouseout=\"OnMouseLeaveSpan\(this\)\"/i", "",$buf);
    $buf = preg_replace("/onmouseover=\"OnMouseOverSpanTran\(this,event\)\"/i", "",$buf);
    $buf = preg_replace("/<span class=\"src_para\">/i", "<span style=\"display:none;\">",$buf);
  } else if (TRANSLATION_ENGINE == 'freetransl') {
    $buf = preg_replace("/\<div(.*)http:\/\/www\.freetranslation\.com\/images\/logo\.gif(.*)\<\/div\>/i", "", $buf);
    $buf = str_replace(array("{L","L}"), array("",""), $buf);
  } else if (TRANSLATION_ENGINE == 'google') {
    $buf = preg_replace("/<iframe src=\"http:\/\/translate\.google\.com\/translate_un[^>]*><\/iframe>/i", "",$buf);
    $buf = preg_replace("/<script>[^<]*<\/script>[^<]*<script src=\"[^\"]*translate_c.js\"><\/script>[^<]*<script>[^<]*_intlStrings[^<]*<\/script>[^<]*<style type=[\"]{0,1}text\/css[\"]{0,1}>\.google-src-text[^<]*<\/style>/i", "",$buf);
    $buf = preg_replace("/_setupIW\(\);_csi\([^\)]*\);/","",$buf);
    $buf = preg_replace("/onmouseout=[\"]{0,1}_tipoff\(\)[\"]{0,1}/i", "",$buf);
    $buf = preg_replace("/onmouseover=[\"]{0,1}_tipon\(this\)[\"]{0,1}/i", "",$buf);
    $buf = preg_replace("/<span class=[\"]{0,1}google-src-text[\"]{0,1}[^>]*>/i", "<span style=\"display:none;\">",$buf);
    $buf = preg_replace("/<span style=\"[^\"]*\" class=[\"]{0,1}google-src-text[\"]{0,1}[^>]*>/i", "<span style=\"display:none;\">",$buf);
  }
  
	if (HARD_CLEAN){
		$out = array();
		$currPos=0;
		$result = "";
		$tagOpenPos = 0;
		$tagClosePos = 0;
		
		while (!($tagOpenPos === false)){
			$beginIdx = $tagClosePos;
      $tagOpenPos = stripos($buf,"<span style=\"display:none;\">",$currPos);
      $tagClosePos = stripos($buf,"</span>",$tagOpenPos);
			if ($tagOpenPos == 0 && ($tagOpenPos === false) && strlen($result) == 0){
				gltr_debug("===>break all!");
				$result = $buf;
				break;
			}
			$offset = substr($buf,$tagOpenPos,$tagClosePos - $tagOpenPos + 7);
			preg_match_all('/<span[^>]*>/U',$offset,$out2,PREG_PATTERN_ORDER);
			$nestedCount = count($out2[0]);
			
			for($i = 1; $i < $nestedCount; $i++){
        $tagClosePos = stripos($buf,"</span>",$tagClosePos + 7);
			}
			if ($beginIdx > 0)$beginIdx += 7;
			
			$result .= substr($buf,$beginIdx,$tagOpenPos - $beginIdx);
			$currPos = $tagClosePos;
		}
		//gltr_debug($result);
		$buf = $result . substr($buf,$beginIdx);//Fixed by adding the last part of the translation: thanks Nick Georgakis!
	}
  
  $buf = gltr_insert_flag_bar($buf);
  
  return $buf;
}

/**
 * 
 * @since 0.9
 */
function gltr_insert_flag_bar($buf){
	$bar = gltr_get_flags_bar();

	$startpos = strpos($buf, FLAG_BAR_BEGIN);
	$endpos = strpos($buf, FLAG_BAR_END);
	if ($startpos > 0 && $endpos > 0){
    $buf = substr($buf, 0, $startpos) . $bar . substr($buf, $endpos + strlen(FLAG_BAR_END));
  } else {
    gltr_debug("Flags bar tokens not found: translation failed or denied");
  }
  
  return $buf;
}

/**
 * 
 * @since 0.9
 */
function gltr_get_extensions_skip_pattern() {
	global $well_known_extensions;
	
	$res = "";
	foreach ($well_known_extensions as $key => $value) {
		$res .= "(?!\.$value)";
	}
	return $res;
}

/**
 * Gets random User Agent to Spoof Browser
 * @since 0.9
 */
function gltr_get_random_UA(){
	global $gltr_ua;
	$tot = count($gltr_ua);
	$id = rand( 0, count($gltr_ua)-1 );
	$ua = $gltr_ua[$id];
	//gltr_debug("Random UA nr $id: $ua");
	return $ua;
}

/**
 * 
 * @since 0.9
 */
function gltr_build_request($host, $http_req) {
  $res = "GET $http_req HTTP/1.0\r\n";
  $res .= "Host: $host\r\n";
  $res .= "User-Agent: " . gltr_get_random_UA() . " \r\n";
  $res .= "Accept: text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5\r\n";
  $res .= "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\n";
  $res .= "Connection: close\r\n";
  $res .= "\r\n";
  return $res;
}

/**
 * 
 * @since 0.9
 */
function gltr_build_flags_bar() {
  echo (gltr_get_flags_bar());
}

/**
 * for backward compatibility (REMOVE?)
 * @since 0.9
 */
function build_flags_bar() {
  echo (gltr_get_flags_bar());
}

/**
 * 
 * @since 0.9
 */
function gltr_get_translated_url($language, $url) {
  if (REWRITEON) {
    $contains_index = (strpos($url, 'index.php')!==false);
    $blog_home_esc = BLOG_HOME_ESCAPED;
    if ($contains_index){
      $blog_home_esc .= '\\/index.php';
    }
		$pattern = '/' . $blog_home_esc . '\\/((' . LANGS_PATTERN . ')[\\/])*(.*)/';

    if (preg_match($pattern, $url)) {
      $uri = preg_replace($pattern, '\\3', $url);
    } else {
      $uri = '';
    }

    $blog_home = BLOG_HOME;
    if ($contains_index){
      $blog_home .= '/index.php';
    }
    if ($language == BASE_LANG)
      $url = $blog_home . '/' . $uri;
    else
      $url = $blog_home . '/' . $language . '/' . $uri;
  } else {
    //REWRITEOFF
    $pattern1 = '/(.*)([&|\?]{1})lang=(' . LANGS_PATTERN . ')(.*)/';
    $pattern2 = '/(.*[&|\?]{1})lang=(' . LANGS_PATTERN . ')(.*)/';

    if ($language == BASE_LANG) {
      $url = preg_replace($pattern1, '\\1\\4', $url);
    } else
      if (preg_match($pattern2, $url)) {
        $url = preg_replace($pattern2, '\\1lang=' . $language . '\\3', $url);
      } else {
        if (strpos($url,'?')===false)
          $url .= '?lang=' . $language;
        else
          $url .= '&lang=' . $language;
      }

  }

  return $url;
}

/**
 * 
 * @since 0.9
 */
function gltr_get_self_url() {
  $full_url = 'http';
  $script_name = '';
  if (isset($_SERVER['REQUEST_URI'])) {
    $script_name = $_SERVER['REQUEST_URI'];
  } else {
    $script_name = $_SERVER['PHP_SELF'];
    if ($_SERVER['QUERY_STRING'] > ' ') {
      $script_name .= '?' . $_SERVER['QUERY_STRING'];
    }
  }
  if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') {
    $full_url .= 's';
  }
  $full_url .= '://';
  if ($_SERVER['SERVER_PORT'] != '80') {
    $full_url .= $_SERVER['HTTP_HOST'] . ':' . $_SERVER['SERVER_PORT'] . $script_name;
  } else {
    $full_url .= $_SERVER['HTTP_HOST'] . $script_name;
  }
  return $full_url;
}

/**
 * 
 * @since 0.9
 */
//rewrite rules definitions
function gltr_translations_rewrite($wp_rewrite) {
  $translations_rules = array('^(' . LANGS_PATTERN . ')$' =>
    'index.php?lang=$matches[1]', '^(' . LANGS_PATTERN . ')/(.+?)$' =>
    'index.php?lang=$matches[1]&url=$matches[2]');
  $wp_rewrite->rules = $translations_rules + $wp_rewrite->rules;
}

/**
 * 
 * @since 0.9
 */
function gltr_get_cookies() {
  $string = '';
  while ($key = key($_COOKIE)) {
    if (preg_match("/^wordpress|^comment_author_email_/", $key)) {
      $string .= $_COOKIE[$key] . ",";
    }
    next($_COOKIE);
  }
  reset($_COOKIE);
  return $string;
}

/**
 * 
 * @since 0.9
 */
function gltr_is_cached($url,$lang){
	global $gltr_cache_dir, $gltr_stale_dir;

  $url_parts = parse_url($url);
  $host = 'http://' . $url_parts['host'];
  $host_escaped = str_replace('/', '\\/', $host);

  $cachedir = $gltr_cache_dir."/$lang";
  $staledir = $gltr_stale_dir."/$lang";
  $uri = preg_replace("/$host_escaped/", '', $url);
  $hash = gltr_hashReqUri($uri);
  $filename = $cachedir . '/' . $hash;
  $stale_filename = $staledir . '/' . $hash;
  return (is_file($filename)||is_file($stale_filename));
  
}

/**
 * 
 * @since 0.9
 */
function gltr_mkdir($dirtomake){
  if (!is_dir($dirtomake)) { 
    if (!@mkdir($dirtomake, 0777)){
     	die("<b>Global Translator has detected a problem with your filesystem permissions:<br />The cache dir <em>$dirtomake</em> cannot be created. <br />Please make readable and writeable the following directory: <br /><em>".WP_CONTENT_DIR."</em>.</b>");
    }
    if(!file_exists($dirtomake) || !is_readable($dirtomake) || !is_writeable($dirtomake)){
    	die("<b>Global Translator has detected a problem with your filesystem permissions:<br />The cache dir <em>$dirtomake</em> cannot be read or modified. <br />Please chmod it in order to make it readable and writeable.</b>");
    }
  }
	
}

/**
 * Gets Translation from cache
 * @since 0.9
 */
function gltr_get_page_content($lang, $url) {
 	global $gltr_cache_dir;
	global $gltr_stale_dir;

  $page = '';
  $hash = gltr_hashReqUri($_SERVER['REQUEST_URI']);
  //gltr_debug("Hashing uri: ".$_SERVER['REQUEST_URI']." to: $hash");

  $cachedir = $gltr_cache_dir;
  $staledir = $gltr_stale_dir;

  //gltr_debug("==>$cachedir");
  gltr_mkdir($cachedir);
  gltr_mkdir($staledir);

	gltr_move_to_new_cache_loc($hash,$lang);				
	gltr_move_to_new_stale_loc($hash,$lang);				
	
  $filename = $cachedir . '/' . $lang . '/' . $hash;
  $stale_filename = $staledir . '/' . $lang . '/' . $hash;
  
  if(file_exists($filename) && (!is_readable($filename) || !is_writeable($filename))){
  	return "<b>Global Translator has detected a problem with your filesystem permissions:<br />The cached file <em>$filename</em> cannot be read or modified. <br />Please chmod it in order to make it readable and writeable.</b>";
  }
  if(file_exists($stale_filename) && (!is_readable($stale_filename) || !is_writeable($stale_filename))){
  	return "<b>Global Translator has detected a problem with your filesystem permissions:<br />The cached file <em>$stale_filename</em> cannot be read or modified. <br />Please chmod it in order to make it readable and writeable.</b>";
  }
  
  if (file_exists($filename) && filesize($filename) > 0) {
    // Insert Template 1.1
    $page = btr_get_trans_template($lang);
    // We are done, just return the file and exit
    gltr_debug("gltr_get_page_content :: returning cached version ($hash) for url:" . gltr_get_self_url());
    $page .= gltr_load_cached_page($filename);      
    $page .= "<!--CACHED VERSION ($hash)-->";
    
    $page = gltr_insert_flag_bar($page); //could be skipped 
		//check if needs to be scheduled for a new translation
		$filetime_days = (time() - filemtime($filename)) / 86400;
		
		if (EXPIRE_TIME > 0 && $filetime_days >= EXPIRE_TIME ){
			gltr_debug("gltr_get_page_content :: The file $filename has been created more than " . EXPIRE_TIME . " days ago. Scheduling for a new translation");
			gltr_move_cached_file_to_stale($hash,$lang);
		}

  } else {

    $url_to_translate = gltr_clean_url_to_translate();
  	gltr_debug("gltr_get_page_content :: Connecting to engine for url:" . $url_to_translate);
    $page = gltr_translate($lang);
    //check the content to be cached
		if (gltr_is_valid_translated_content($page)) {
			$gltr_last_cached_url = gltr_get_self_url();
      gltr_debug("gltr_get_page_content :: caching ($filename) [".strlen($page)."] url:" . $gltr_last_cached_url);
      gltr_save_cached_page($page,$filename);
      $page .= "<!--NOT CACHED VERSION: ($hash)-->";
      if (file_exists($stale_filename)){
      	unlink($stale_filename);
      }
    } else {
    	gltr_debug("gltr_get_page_content :: translation not available. Switching to stale for url: $url_to_translate");
	    if (file_exists($stale_filename) && filesize($stale_filename) > 0) {
	      gltr_debug("gltr_get_page_content :: returning stale version ($hash) for url:" . $url_to_translate);

	      $page = gltr_load_cached_page($stale_filename);
		    $page = gltr_insert_flag_bar($page); //could be skipped 
	      $page .= "<!--STALE VERSION: ($hash)-->";
	 			$from_cache = true;
	    } else {
          $btr_redirect_url = $_GET['gltr_redir'];
          $resource = $btr_redirect_url;
			    //$resource = gltr_build_translation_url(BASE_LANG, $lang, $url_to_translate);
			  
          //no cache, no translated,no stale
	      	$page = gltr_make_server_redirect_page($resource);
      }
    }
  }
  
  return $page;
}

/**
 * 
 * @since 0.9
 */
function gltr_save_cached_page($data,$filename){
	if (COMPRESS_CACHE && function_exists('gzcompress')){
		gltr_debug("gltr_save_cached_page :: using zlib for file: $filename");
		$data = gzcompress($data, 9);
	} else {
		gltr_debug("gltr_save_cached_page :: NOT using zlib for file: $filename");
	} 
  $handle = fopen($filename, "wb");
  if (flock($handle, LOCK_EX)) { // do an exclusive lock
    fwrite($handle, $data); //write
    flock($handle, LOCK_UN); // release the lock
  } else {
    fwrite($handle, $data); 
  }
  fclose($handle);
}

/**
 * 
 * @since 0.9
 */
function gltr_load_cached_page($filename){
	$data = file_get_contents($filename);
	if (function_exists('gzuncompress')){
		if (($tmp = @gzuncompress($data))){
			$data = $tmp;
			if (!COMPRESS_CACHE){
				//save the unzipped version
				gltr_save_cached_page($data,$filename);
			}
		} else if (COMPRESS_CACHE) {
			//save the zipped version
			gltr_save_cached_page(file_get_contents($filename),$filename);
		}
		
	}
	return $data;
}

/**
 * 
 * @since 0.9
 */
function gltr_hashReqUri($uri) {
	
	$uri = urldecode($uri);//Adde
  $req = preg_replace('/(.*)\/$/', '\\1', $uri);
  $req = preg_replace('/#.*$/', '', $req);
  $hash = str_replace(array('?','<','>',':','\\','/','*','|','"'), '_', $req);
  return $hash;
}

/**
 * 
 * @since 0.9
 */
function gltr_insert_my_rewrite_query_vars($vars) {
  array_push($vars, 'lang', 'url');
  return $vars;
}

/**
 * 
 * @since 0.9
 */
function gltr_insert_my_rewrite_parse_query($query) {
  global $gltr_cache_dir,$gltr_is_translated_page;
  $gltr_result = "";	  
  if (isset($query->query_vars['lang'])) {
  	$lang = $query->query_vars['lang'];
    $url = $query->query_vars['url'];

    if (empty($url)) {
      $url = '';
    }

    if (!is_dir($gltr_cache_dir)){
      if (!is_readable(WP_CONTENT_DIR) || !is_writable(WP_CONTENT_DIR) ){
        header("HTTP/1.1 404 Not Found");
        header("Status: 404 Not Found");
        die ("Unable to complete Global Translator initialization. Plese make writable and readable the following directory:
        <ul><li>".WP_CONTENT_DIR."</li></ul>");
      }
    }

    if (gltr_not_translable_uri()){
      gltr_debug("Cannot Translate");
   		return;
		}

  	$chosen_langs = get_option('gltr_preferred_languages');

		$can_translate = true;
		$self_url = gltr_get_self_url();
		$self_uri = preg_replace("/" . BLOG_HOME_ESCAPED . "/", '', $self_url);
		
  	if (!in_array($lang, $chosen_langs)){
      $redirect = gltr_clean_url_to_translate($self_url);
  		gltr_debug("Blocking request for not chosed language:$lang redirecting to original page: $redirect");
  		header("Location: $redirect", TRUE, 302);
  		die();
  	}
	  
	  if (!gltr_is_user_agent_allowed() && BAN_PREVENTION){
  		gltr_debug("Limiting bot/crawler access to resource:".$url);
  		header("HTTP/1.1 404 Not Found");
			header("Status: 404 Not Found");
  		$gltr_result = NOT_FOUND;
  		$can_translate = false;
  	}
  	
  	if (preg_match("/^(" . LANGS_PATTERN . ")$/", $url) || 
  			preg_match("/^(" . LANGS_PATTERN . ")\/(.+)$/", $url) ){
  		gltr_debug("Fixing request for nested translation request:".$lang."|".$url."|".$self_url);
  		$redirect = preg_replace("/(.*)\/(" . LANGS_PATTERN . ")\/(" . LANGS_PATTERN . ")\/(.*)$/", "\\1/\\2/\\4", $self_url);
      header("Location: $redirect", TRUE, 302);
      die();
  	}
		if (REWRITEON && strpos($self_url,'?')===false){
			if (strpos($self_url,'&')>0){
        gltr_debug("Blocking bad request:".$lang."|".$url);
	  		header("HTTP/1.1 404 Not Found");
				header("Status: 404 Not Found");
	  		$gltr_result = NOT_FOUND;
	  		$can_translate = false;
			} else if (substr($self_url, -1) != '/' && strpos($self_uri,'.') === false){
	  		header("HTTP/1.1 302 Moved Temporarily");
	  		header("Location: " . gltr_get_self_url() . '/');
	  		die();  		
			} else if (substr($self_url, -1) == '/' && strpos($self_uri,'.') !== false){
        header("HTTP/1.1 302 Moved Temporarily");
        $loc = rtrim(gltr_get_self_url(),'/');
        header("Location: " . $loc);
        die();      
			}
		}  	
  	if ($can_translate) {
      $gltr_result = gltr_get_page_content($lang, $url);
		}
		die($gltr_result);   
  }
}

/**
 * 
 * @since 0.9
 */
function gltr_add_options_page() {
 $path = dirname(__FILE__).DIRECTORY_SEPARATOR;
 $file = $path. 'options-translator.php';
 add_options_page('Bens Translator Options','Bens Translator',8,$file);
}

/**
 * 
 * @since 0.9
 */
function gltr_debug($msg) {
  if (DEBUG) {
    $today = date("Y-m-d H:i:s ");
    $myFile = dirname(__file__) . "/debug.log";
    $myFile = str_replace('/core', '', $myFile);
    $fh = fopen($myFile, 'a') or die("Can't open debug file. Please manually create the 'debug.log' file (inside the 'global-translator' directory) and make it writable.");
    $ua_simple = preg_replace("/(.*)\s\(.*/","\\1",$_SERVER['HTTP_USER_AGENT']);
    //fwrite($fh, $today . " [from: ".$_SERVER['REMOTE_ADDR']."|$ua_simple] - [mem:" . memory_get_usage() . "] " . $msg . "\n");
    if (is_array($msg)){
    	foreach($msg as $key => $item)
    		fwrite($fh, $today . " [from: ".$_SERVER['REMOTE_ADDR']."|$ua_simple] - " . $key . "=>" . $item . "\n");
    }else
    	fwrite($fh, $today . " [from: ".$_SERVER['REMOTE_ADDR']."|$ua_simple] - " . $msg . "\n");
    fclose($fh);
  }
}

/**
 * 
 * @since 0.9
 */
function gltr_debug_ua($msg) {
  if (DEBUG_UA) {
    $today = date("Y-m-d H:i:s ");
    $myFile = dirname(__file__) . "/ua.log";
    $fh = fopen($myFile, 'a') or die("Can't open debug file. Please manually create the 'ua.log' file (inside the 'global-translator' directory) and make it writable.");
    $ua_simple = preg_replace("/(.*)\s\(.*/","\\1",$_SERVER['HTTP_USER_AGENT']);
    //fwrite($fh, $today . " [from: ".$_SERVER['REMOTE_ADDR']."|$ua_simple] - [mem:" . memory_get_usage() . "] " . $msg . "\n");
    fwrite($fh, $today . " [from: ".$_SERVER['REMOTE_ADDR']."|$ua_simple] - " . $msg . "\n");
    fclose($fh);
  }
}

/**
 * 
 * @since 0.9
 */
function gltr_not_translable_uri(){
  $not_translable = array("share-this","download.php");
  $url = gltr_get_self_url();
  if (isset($url))
    $url = strtolower($url);
  else
    $url = "";
  if ($url == "") {
    return false;
  } else {
    while (list($key, $val) = each($not_translable)) {
      if (strstr($url, strtolower($val))) {
        gltr_debug("Detected and blocked untranslable uri: $url");
        return true;
      }
    }
  }  
  return false;
}

/**
 * 
 * @since 0.9
 */
function gltr_is_browser() {
  $browsers_ua = array(
  "MSIE", 
  "UP.Browser",
  "Mozilla", 
  "Opera", 
  "NSPlayer", 
  "Avant Browser",
  "Konqueror",
  "Safari",
  "Netscape"  
  );
  if (isset($_SERVER['HTTP_USER_AGENT']))
    $ua = strtoupper($_SERVER['HTTP_USER_AGENT']);
  else
    $ua = "";

  if ($ua == "") {
    return false;
  } else {
    while (list($key, $val) = each($browsers_ua)) {
      if (strstr($ua, strtoupper($val))) {
        return true;
      }
    }
  }
  return false;
}

/**
 * Defines bad user agents
 * For Bad Robot blocking 
 * @since 0.9
 */
function gltr_is_user_agent_allowed() {
  $not_allowed = array("Wget", "EmailSiphon", "WebZIP", "MSProxy/2.0", "EmailWolf",
    "webbandit", "MS FrontPage", "GetRight", "AdMuncher", "Sqworm", "SurveyBot",
    "TurnitinBot", "WebMirror", "WebMiner", "WebStripper", "WebSauger", "WebReaper",
    "WebSite eXtractor", "Teleport Pro", "CherryPicker", "Crescent Internet ToolPak",
    "EmailCollect", "ExtractorPro", "NEWT ActiveX", "sexsearcher", "ia_archive",
    "NameCrawler", "Email spider", "GetSmart", "Grabber", "GrabNet", "EmailHarvest",
    "Go!Zilla", "LeechFTP", "Vampire", "SmartDownload", "Sucker", "SuperHTTP",
    "Collector", "Zeus", "Telesoft", "URLBlaze", "VobSub", "Vacuum", "Space Bison",
    "WinWAP", "3D-FTP", "Wapalizer", "DTS agent", "DA 5.", "NetAnts", "Netspider",
    "Disco Pump", "WebFetch", "DiscoFinder", "NetZip", "Express WebPictures",
    "Download Demon", "eCatch", "WebAuto", "Offline Expl", "HTTrack",
    "Mass Download", "Mister Pix", "SuperBot", "WebCopier", "FlashGet", "larbin",
    "SiteSnagger", "FlashGet", "NPBot", "Kontiki","Java","ETS V5.1",
    "IDBot", "id-search", "libwww", "lwp-trivial", "curl", "PHP/", "urllib", 
    "GT::WWW", "Snoopy", "MFC_Tear_Sample", "HTTP::Lite", "PHPCrawl", "URI::Fetch", 
    "Zend_Http_Client", "http client", "PECL::HTTP","libwww-perl","SPEEDY SPIDER",
    "YANDEX","YETI","DOCOMO","DUMBOT","PDFBOT","CAZOODLEBOT","RUNNK","ICHIRO",
    "SPHERE SCOUT");

  $allowed = array("compatible; MSIE", "T720", "MIDP-1.0", "AU-MIC", "UP.Browser",
    "SonyEricsson", "MobilePhone SCP", "NW.Browser", "Mozilla", "UP.Link",
    "Windows-Media-Player", "MOT-TA02", "Nokia", "Opera/7", "NSPlayer",
    "GoogleBot", "Opera/6", "Panasonic", "Thinflow", "contype", "klondike", "UPG1",
    "SEC-SGHS100", "Scooter", "almaden.ibm.com",
    "SpaceBison/0.01 [fu] (Win67; X; ShonenKnife)", "Internetseer","MSNBOT-MEDIA/",
    "MEDIAPARTNERS-GOOGLE","MSNBOT","Avant Browser","GIGABOT","OPERA");

  if (isset($_SERVER['HTTP_USER_AGENT']))
    $ua = strtoupper($_SERVER['HTTP_USER_AGENT']);
  else
    $ua = "";
  if ($ua == "") {
    return false;
  } else {
    while (list($key, $val) = each($not_allowed)) {
      if (strstr($ua, strtoupper($val))) {
        //gltr_debug("Detected and blocked user agent: $ua");
        return false;
      }
    }
  }
  $notknown = 1;
  while (list($key, $val) = each($allowed)) {
    if (strstr($ua, strtoupper($val))) {
      $notknown = 0;
    }
  }
  if ($notknown) {
    gltr_debug_ua("$ua");
  }
  return true;
}

/**
 * 
 * @since 0.9
 */
function gltr_erase_common_cache_files($post_ID) {
	global $gltr_cache_dir;
	global $gltr_stale_dir;
	global $gltr_engine;
	
	$start= round(microtime(true),4);
	
  $single_post_pattern = "";

	$categories = array();
	$tags =  array();
	$patterns = array();

	if (isset($post_ID)){
		$post = get_post($post_ID); 
		if ($post->post_status != 'publish'){
			gltr_debug("Post not yet published (status=".$post->post_status."): no cached files to erase");
			return;
		} else {
			gltr_debug("Post published ok to cached files erase");
		}
		if (function_exists('get_the_category')) $categories = get_the_category($post_ID);

		if (function_exists('get_the_tags')) $tags = get_the_tags($post_ID);
  	if (REWRITEON) {
  		$uri = substr (get_permalink($post_ID), strlen(get_option('home')) );
  		$single_post_pattern = gltr_hashReqUri($uri);
			if (isset($categories) && is_array($categories)){
				foreach($categories as $category) { 
			    $patterns[] = '_category_' . strtolower($category->slug); 
				} 
			} else {
		    $patterns[] = '_category_'; 
			}
			if (isset($tags) && is_array($tags)){
				foreach($tags as $tag) { 
			    $patterns[] = '_tag_' . $tag->slug; 
				}
			}else{
		    $patterns[] = '_tag_'; 
			}			
  	} else {
  		$single_post_pattern = $post_ID;
			if (isset($categories) && is_array($categories)){
				foreach($categories as $category) { 
			    $patterns[] = '_cat=' . strtolower($category->cat_ID); 
				} 
			} else {
		    $patterns[] = '_cat='; 
			}
			if (isset($tags) && is_array($tags)){
				foreach($tags as $tag) { 
			    $patterns[] = '_tag=' . $tag->slug;  
				}
			}else{
		    $patterns[] = '_tag='; 
			}
  	}

		$datepattern = "";
		$post_time = $post->post_date;
		if (isset($post_time) && function_exists('mysql2date')){
			$year = mysql2date(__('Y'), $post_time);
			$month = mysql2date(__('m'), $post_time);
			//gltr_debug("==>post y=$year m=$month");
			if (REWRITEON){
				$datepattern = $year . "_" . $month;
			} else {
				$datepattern = "$year$month";
			}
		} else {
			if (REWRITEON){
				$datepattern = "[0-9]{4}_[0-9]{2}";
			} else {
				$datepattern = "[0-9]{6}";
			}
		}
  	
  	
	} else {
			gltr_debug("Post ID not set");
	}
	
  $transl_map = $gltr_engine->get_languages_matrix();

  $translations = $transl_map[BASE_LANG];
  foreach ($translations as $key => $value) {
	  $cachedir = $gltr_cache_dir . "/$key";
	  gltr_debug("begin clean $key");
  if (file_exists($cachedir) && is_dir($cachedir) && is_readable($cachedir)) {
    $handle = opendir($cachedir);
    while (FALSE !== ($item = readdir($handle))) {
    	if( $item != '.' && $item != '..' && $item != 'stale' && !is_dir($item)){
	    		gltr_delete_empty_cached_file($item,$key);
    		$donext = true;
				foreach($patterns as $pattern) { 
          if(strstr($item, $pattern)){
	            gltr_move_cached_file_to_stale($item,$key);
            $donext = false;
            break;
          }
				} 
				if ($donext){
		    	if (REWRITEON) {
		        if(	preg_match('/_(' . LANGS_PATTERN . ')_'.$datepattern.'$/', $item) ||
								preg_match('/_(' . LANGS_PATTERN . ')_page_[0-9]+$/', $item) ||
								preg_match('/_(' . LANGS_PATTERN . ')$/', $item) ||
								preg_match('/_(' . LANGS_PATTERN . ')'.$single_post_pattern.'$/', $item)) {
								  gltr_debug("begin clean $key, stage 2");
			        		gltr_move_cached_file_to_stale($item,$key);
		        }
		      } else {
		      	//no rewrite rules
		        if(	preg_match('/_p='.$single_post_pattern.'$/', $item) ||
		        		preg_match('/_paged=[0-9]+$/', $item) ||
		        		preg_match('/_m='.$datepattern.'$/', $item) ||
		        		preg_match('/_lang=(' . LANGS_PATTERN . ')$/', $item)) {
		        		  gltr_debug("begin clean $key, stage 3");
			        		gltr_move_cached_file_to_stale($item,$key);
		        }
		      }
		    }
    	}
    }
    closedir($handle);
  }
  }
  //gltr_debug("end clean");
  $end= round(microtime(true),4);
 	gltr_debug("Cache cleaning process total time:". ($end - $start) . " seconds");
}

/**
 * Deletes Cache file if empty
 * @since 0.9
 */
function gltr_delete_empty_cached_file($filename,$lang){
	global $gltr_cache_dir;
	global $gltr_stale_dir;
  $cachedir = $gltr_cache_dir."/$lang";
  $path = $cachedir.'/'.$filename;
  if (file_exists($path) && is_file($path) && filesize($path) == 0){
    gltr_debug("Erasing empty file: $path");
  	unlink($path);
  }
}

/**
 * 
 * @since 0.9
 */
function gltr_move_to_new_cache_loc($filename,$lang){
	global $gltr_cache_dir;

	$cachedir = dirname(__file__) . '/cache';
  if (is_dir($cachedir)) {
  $src = $cachedir . '/' . $filename;
  $dst = $gltr_cache_dir . '/' . $filename;
  if (file_exists($src) && !file_exists($dst) ){
	  if (!@rename($src,$dst)){
		  gltr_debug("Unable to move cached file $src to stale $dst");
	  } else {
		  gltr_debug("Moving cached file $src to stale $dst");
	  }
	}
}
  gltr_mkdir($gltr_cache_dir . '/' . $lang);
  $src = $gltr_cache_dir . '/' . $filename;
  $dst = $gltr_cache_dir . '/' . $lang . '/' . $filename;
  if (file_exists($src) && !file_exists($dst)){
    if (!@rename($src,$dst)){
      gltr_debug("Unable to move cached file $src to cache/lang $dst");
    } else {
      gltr_debug("Moving cached file $src to cache/lang $dst");
    }
  }  
}

/**
 * 
 * @since 0.9
 */
function gltr_move_to_new_stale_loc($filename,$lang){
	global $gltr_stale_dir;

	$staledir = dirname(__file__) . '/cache/stale';
  if (is_dir($staledir)) {
  $src = $staledir . '/' . $filename;
  $dst = $gltr_stale_dir . '/' . $filename;
  if (file_exists($src) && !file_exists($dst)){
		if (!@rename($src,$dst)){
		  gltr_debug("Unable to move cached file $src to stale $dst");
	  } else {
		  gltr_debug("Moving cached file $src to stale $dst");
	  }
	}
}
  gltr_mkdir($gltr_stale_dir . '/' . $lang);
  $src = $gltr_stale_dir . '/' . $filename;
  $dst = $gltr_stale_dir . '/' . $lang . '/' . $filename;
  if (file_exists($src) && !file_exists($dst)){
    if (!@rename($src,$dst)){
      gltr_debug("Unable to move stale file $src to stale/lang $dst");
    } else {
      gltr_debug("Moving stale file $src to stale/lang $dst");
    }
  }
}

/**
 * 
 * @since 0.9
 */
function gltr_move_cached_file_to_stale($filename,$lang){
  if (EXPIRE_TIME > 0 && $filetime_days >= EXPIRE_TIME ){
	global $gltr_cache_dir;
	global $gltr_stale_dir;
	$cachedir = $gltr_cache_dir."/$lang";
	$staledir = $gltr_stale_dir."/$lang";
  $src = $cachedir . '/' . $filename;
  $dst = $staledir . '/' . $filename;
  if (!@rename($src,$dst)){
	  gltr_debug("Unable to move cached file $src to stale $dst");
  } else {
	  gltr_debug("Moving cached file $src to stale $dst");
  }
  }
  ELSE {
    $expire_time_error = EXPIRE_TIME;
    gltr_debug("Created less than $expire_time_error day(s) ago");
  }
}

/**
 * 
 * @since 0.9
 */
function gltr_delete_cached_file($filename,$lang){
	global $gltr_cache_dir;
  $cachedir = $gltr_cache_dir."/$lang";
  $path = $cachedir.'/'.$filename;
  if (file_exists($path) && is_file($path)){
    gltr_debug("Erasing $path");
  	unlink($path);
  }

}

/**
 * Register Sidebar Widget
 * @since 0.9
 */
function widget_global_translator_init() {
  if(!function_exists('register_sidebar_widget')) { return; }
  function widget_global_translator($args) {
    extract($args);
    echo $before_widget . $before_title . "Translator" . $after_title;
    gltr_build_flags_bar();
    echo $after_widget;
  }
  register_sidebar_widget('Bens Translator','widget_global_translator');
}

/**
 * 
 * @since 0.9
 */
function gltr_get_flags_bar() {
  global $gltr_engine, $wp_query, $gltr_merged_image;
  $num_cols = BAR_COLUMNS;
  if (HTML_BAR_TAG == 'MAP'){
    update_option('gltr_html_bar_tag', 'DIV');
  }
	if (!isset($gltr_engine) || $gltr_engine == null ){
		gltr_debug("WARNING! GT Options not correctly set!");
		return "<b>Global Translator not configured yet. Please go to the Options Page</b>";
	}
  
  $buf = '';
  $transl_map = $gltr_engine->get_languages_matrix();
  $translations = $transl_map[BASE_LANG];
  gltr_debug("Matrix Error Debug 2: $transl_map , $translations");
  $transl_count = count($translations); 
  $buf .= "\n" . FLAG_BAR_BEGIN; //initial marker

  if (HTML_BAR_TAG == 'TABLE')
    $buf .= "<table border='0'><tr>";
  else if (HTML_BAR_TAG == 'DIV')
    $buf .= "<div id=\"translation_bar\">";
  

  $curr_col = 0;
  $curr_row = 0;
  $dst_x = 0;
  $dst_y = 0;
  $map_left=0;
  $map_top=0;
  $map_right=16;
  $map_bottom=11;
  $grid;

  //filter preferred
  $preferred_transl = array();
  foreach ($translations as $key => $value) {
    if ($key == BASE_LANG || in_array($key, get_option('gltr_preferred_languages')))
      $preferred_transl[$key] = $value;
  }
  $num_rows=1;
  if ($num_cols > 0){
    $num_rows = (int)(count($preferred_transl)/$num_cols);
    if (count($preferred_transl)%$num_cols>0)$num_rows+=1;
  }

  foreach ($preferred_transl as $key => $value) {
    if ($curr_col >= $num_cols && $num_cols > 0) {
      if (HTML_BAR_TAG == 'TABLE' || HTML_BAR_TAG == 'TEXT') $buf .= "</tr><tr>";
      $curr_col = 0;
      $dst_x = 0;
      $map_left = 0;
      $map_right = 16;
      $curr_row++;
    }
    $dst_y = $curr_row * 15;
    $map_top = $curr_row * 15;
    $map_bottom = $curr_row * 15 + 11;

    $flg_url = gltr_get_translated_url($key, gltr_get_self_url());
    $flg_image_url = gltr_get_flag_image($key);
    $flg_image_path = gltr_get_flag_image_path($key);

    if (HTML_BAR_TAG == 'TABLE') $buf .= "<td>";
    
    if (HTML_BAR_TAG_FLAG == 'TEXT') {
      if (HTML_BAR_TAG == 'TABLE') {  
        $buf .= "<td>";
        $buf .= "<a id='flag_$key' href='$flg_url' hreflang='$key' $lnk_attr>$value</a>";
      }
      else {
        $buf .= "<a id='flag_$key' href='$flg_url' hreflang='$key' $lnk_attr>$value</a>";
      }
    }
    
    else{
    $buf .= "<a id='flag_$key' href='$flg_url' hreflang='$key' $lnk_attr><img id='flag_img_$key' src='$flg_image_url' alt='$value flag' title='$value'  border='0' /></a>";
    }
    
    
    if (HTML_BAR_TAG == 'TABLE') $buf .= "</td>";
    if ($num_cols > 0) $curr_col += 1;

  }//end foreach ($preferred_transl as $key => $value) {

  while ($curr_col < $num_cols && $num_cols > 0) {
    if (HTML_BAR_TAG == 'TABLE') $buf .= "<td>&nbsp;</td>";
    $curr_col += 1;
  }


  if ($num_cols == 0)
    $num_cols = count($translations);
     
  $flg_image_path_ben = gltr_get_flag_image_path_copy();
  
  $btr_link = "<a style=\"font-size:9px;\" href=\"http://benosullivan.co.uk\">Bens Translator</a>";
 
    if (HTML_BAR_TAG == 'TABLE')
    $buf .= "</tr><tr><td colspan=\"$num_cols\">$btr_link</td></tr></table>";
  else if (HTML_BAR_TAG == 'DIV')
    $buf .= "<div id=\"transl_sign\">$btr_link</div></div>";
  else
    $buf .= "";
  $buf .= FLAG_BAR_END . "\n"; //final marker
  return $buf;
}

/**
 * Includes Header Template for Visitors
 * @since 1.1
 */
function btr_get_trans_template() {
  $btr_translate_template = get_option('btr_translate_template');
  
  if ($btr_translate_template == TRUE){
    $lang = get_option('gltr_base_lang');
    $btr_trans_lang = btr_decode_lang_code($lang);
    $btr_get_trans_template_string = "This page has been translated from ";
    $btr_get_trans_template_string .= $btr_trans_lang;
    require_once (dirname(__file__).'/header_template.php');
  }
}

/**
 * Includes Header Template for Visitors
 * @since 1.1
 */
function btr_decode_lang_code($lang) { 
$btr_lang_code = array( 'zh-CN' => 'Chinese (Simplified)',
                        'zh-TW' => 'Chinese (Traditional)',
									     'it'    => 'Italian',
									     'ko'    => 'Korean',
									     'pt'    => 'Portuguese',
									     'en'    => 'English',
									     'de'    => 'German',
									     'fr'    => 'French',
									     'es'    => 'Spanish',
									     'ja'    => 'Japanese',
									     'ar'    => 'Arabic',
									     'ru'		=> 'Russian',
									     'el'    => 'Greek',
									     'nl'		=> 'Dutch',
								       'bg'		=> 'Bulgarian',
								       'cs'		=> 'Czech',
								       'hr'		=> 'Croatian',
								       'da'		=> 'Danish',
								       'fi'		=> 'Finnish',
								       'pl'		=> 'Polish',
								       'sv'		=> 'Swedish',
    								   'no'		=> 'Norwegian',
								       'iw'		=> 'Hebrew',
								       'sr'		=> 'Serbian',
								       'sk'		=> 'Slovak',
                       'th'    => 'Thai',
                       'tr'    => 'Turkish',
                       'hu'    => 'Hungarian'                    
                      );
                      
                      $btr_lang_decode = $btr_lang_code[$lang];
                      return $btr_lang_decode;
}
?>