<?php
/**
 * This file is the Admin page for the Options
 * @since 0.9
 */
//Zero Settings for Cache Information
$gltr_stale_size = 0;
$gltr_cache_size = 0;
$gltr_cached_files_num = 0;
$gltr_stale_files_num = 0;
$showstats = false;

// Get Amount of files in directory for settings page
function gltr_files_stats($dir,$exclusions=""){
  //gltr_debug("====>CALC: $dir");
	$res = array("num"=>0,"size"=>0);
  if (file_exists($dir) && is_dir($dir) && is_readable($dir)) {
  	$files = glob($dir . '/*');
    if (is_array($files)){
      foreach($files as $path){
          if ($exclusions != "" && strpos($path,$exclusions)!==false) {
            //gltr_debug("$dir: EXCLUDING====>$item");
          	continue;
    }
          if (is_dir($path)){
          	//gltr_debug("====>Found dir: $path");
          	$rres = gltr_files_stats($path, $exclusions);
            $res["size"] += $rres["size"];
            $res["num"] += $rres["num"];
            $i2++;
          }else if (file_exists($path) && is_file($path))
            $res["size"] += filesize($path);
            $res["num"]++;
  }
      
      }
    }
  //Removes Folders from count (1.0)
  $res["num"] = $res["num"] - $i2;
  return $res;
  }

// Get Current Files in Cache for Info
function gltr_init_info(){
	global $gltr_stale_size;
	global $gltr_cache_size;
	global $gltr_cached_files_num;
	global $gltr_stale_files_num;
	global $gltr_cache_dir;
	global $gltr_stale_dir;
	//cachedir
  $res_cache = gltr_files_stats($gltr_cache_dir, "stale");
  $gltr_cache_size = $res_cache["size"];
  $gltr_cached_files_num = $res_cache["num"];
  //staledir
  $res_cache = gltr_files_stats($gltr_stale_dir);
  $gltr_stale_size = $res_cache["size"];
  $gltr_stale_files_num = $res_cache["num"];
}

/**
 * 
 * @since 0.9
 */
function gltr_get_last_cached_file_time(){
	$res = -1;
  $last_connection_time = get_option("gltr_last_connection_time");
  if ($last_connection_time > 0){
	  $now = time();
	  $res = $now - $last_connection_time;
  }
	return $res;
}

load_plugin_textdomain('gltr'); // NLS

//This sets the link to the plugin admin page
$location = get_option('siteurl') . '/wp-admin/admin.php?page=bens-translator/core/options-translator.php';
	
$diff_time = gltr_get_last_cached_file_time();

/**
 * Checks whether form was posted and updates settings
 * @since 0.9
 */
if (isset($_POST['stage'])){
	//submitting something
	$gltr_base_lang 						= $_POST['gltr_base_lang'];
	$gltr_col_num 							= $_POST['gltr_col_num'];
	$gltr_html_bar_tag 					= $_POST['gltr_html_bar_tag'];
	$gltr_html_bar_tag_flag 		= $_POST['gltr_html_bar_tag_flag'];
	$gltr_my_translation_engine = $_POST['gltr_my_translation_engine'];
	$gltr_conn_interval 				= $_POST['gltr_conn_interval'];
	$gltr_cache_expire_time 		= $_POST['gltr_cache_expire_time'];
	$btr_translate_template     = $_POST['btr_translate_template'];                        

	if (isset($_POST['gltr_preferred_languages']))
		$gltr_preferred_languages = $_POST['gltr_preferred_languages'];
	
	if(isset($_POST['gltr_enable_debug'])) 
		$gltr_enable_debug = true; 
	else 
		$gltr_enable_debug = false;

	if(isset($_POST['gltr_ban_prevention'])) 
		$gltr_ban_prevention = true; 
	else 
		$gltr_ban_prevention = false;
	
	if(isset($_POST['gltr_sitemap_integration'])) 
		$gltr_sitemap_integration = true; 
	else 
		$gltr_sitemap_integration = false;
	
	if(isset($_POST['gltr_compress_cache'])) 
		$gltr_compress_cache = true; 
	else 
		$gltr_compress_cache = false;
	
	
	
	if ('change' == $_POST['stage']) {
		//recalculate some things
		$gltr_my_translation_engine = $_POST['gltr_my_translation_engine'];
		$gltr_preferred_languages = get_option('gltr_preferred_languages');
	} else if ('process' == $_POST['stage']){
	  if(!empty($_POST["gltr_erase_cache"])) {
	
	  } else {
	  	//update options button pressed

      $iserror = false;
	    if (count ($gltr_preferred_languages) == 0) {
	      $message .= "Error: you must choose almost one of the available translations.";
	      $iserror = true;
	    }
	    
	    if(!$iserror) {
        if (file_exists($gltr_merged_image) && is_file($gltr_merged_image))
          unlink($gltr_merged_image);
	      update_option('gltr_base_lang', $_POST['gltr_base_lang']);
	      update_option('gltr_col_num', $_POST['gltr_col_num']);
	      update_option('gltr_html_bar_tag', $_POST['gltr_html_bar_tag']);
	      update_option('gltr_html_bar_tag_flag', $_POST['gltr_html_bar_tag_flag']);
	      update_option('gltr_my_translation_engine', $_POST['gltr_my_translation_engine']);
	      update_option('gltr_preferred_languages', array());
	      update_option('gltr_preferred_languages', $_POST['gltr_preferred_languages']);
				update_option("gltr_last_connection_time",time());
				update_option("gltr_translation_status","unknown");
				update_option('btr_translate_template', $_POST['btr_translate_template']);
	      $diff_time = -1;

	      $conn_int = $_POST['gltr_conn_interval'];
	      if (!is_numeric($conn_int))$conn_int = 580;
	      update_option('gltr_conn_interval', $conn_int);
				$gltr_conn_interval = $conn_int;
				
	      $exp_time = $_POST['gltr_cache_expire_time'];
	      if (!is_numeric($exp_time))$exp_time = 30;
	      update_option('gltr_cache_expire_time', $exp_time);
				$gltr_cache_expire_time = $exp_time;
				
	
	      if(isset($_POST['gltr_ban_prevention']))
	        update_option('gltr_ban_prevention', true);
	      else
	        update_option('gltr_ban_prevention', false);

	      if(isset($_POST['gltr_sitemap_integration']))
	        update_option('gltr_sitemap_integration', true);
	      else
	        update_option('gltr_sitemap_integration', false);

	      if(isset($_POST['gltr_compress_cache']))
	        update_option('gltr_compress_cache', true);
	      else
	        update_option('gltr_compress_cache', false);
	
	
	      if(isset($_POST['gltr_enable_debug']))
	        update_option('gltr_enable_debug', true);
	      else
	        update_option('gltr_enable_debug', false);
	
	
				$wp_rewrite->flush_rules();
	      $message = "Options saved.";
	    }
	  }
	}		
} 
/**
 * Page was not posted and opened from menu
 * Loads Settings from DB 
 * @since 0.9
 */
else {
	$gltr_base_lang = get_option('gltr_base_lang');
	$gltr_col_num = get_option('gltr_col_num');
	$gltr_html_bar_tag = get_option('gltr_html_bar_tag');
	$gltr_html_bar_tag_flag = get_option('gltr_html_bar_tag_flag');
	$gltr_my_translation_engine = get_option('gltr_my_translation_engine');
	$gltr_preferred_languages = get_option('gltr_preferred_languages');
	$gltr_ban_prevention = get_option('gltr_ban_prevention');
	$gltr_sitemap_integration = get_option('gltr_sitemap_integration');
	$gltr_compress_cache = get_option('gltr_compress_cache');
	
	$gltr_enable_debug = get_option('gltr_enable_debug');
	$gltr_conn_interval = get_option('gltr_conn_interval');
	$gltr_cache_expire_time = get_option('gltr_cache_expire_time');
	$btr_translate_template = get_option('btr_translate_template');


	$gltr_current_engine = $gltr_available_engines[$gltr_my_translation_engine];
	$gltr_lang_matrix = $gltr_current_engine->get_languages_matrix();
	if (count($gltr_preferred_languages) == 0) {
		$i = 0;
		foreach($gltr_lang_matrix[$gltr_base_lang] as $lang_key => $lang_value){
			if ($lang_key == $gltr_base_lang) continue;
			$gltr_preferred_languages[]=$lang_key;
			$i++;
		}
		update_option('gltr_preferred_languages', $gltr_preferred_languages);
	}

  $cachedir = $gltr_cache_dir;
  
  $message = "";

  if (!is_writeable(dirname(__file__))){
    $message = "Unable to complete Global Translator initialization. Please make writable and readable the following directory:
    <ul><li>".dirname(__file__)."</li></ul>";
  } else
  if (!is_dir($cachedir) && (!is_readable(WP_CONTENT_DIR) || !is_writable(WP_CONTENT_DIR) )){
    $message = "Unable to complete Global Translator initialization. Please make writable and readable the following directory:
    <ul><li>".WP_CONTENT_DIR."</li></ul>";
  } else {
  
  if (!is_dir($cachedir)){
    if(!mkdir($cachedir, 0777)){
      $message = "Unable to complete Global Translator initialization. Please manually create and make readable and writeable the following directory:
      <ul><li>".WP_CONTENT_DIR."</li></ul>";
    }
  } else if (!is_readable($cachedir) || !is_writable($cachedir) ){
    $message = "Unable to complete Global Translator initialization. Please make readable and writeable the following directory:
    <ul><li>".$cachedir."</li></ul>";
  }

  if (is_dir($cachedir) && is_readable($cachedir) && is_writable($cachedir)){
    $staledir = $gltr_stale_dir;
    if (!is_dir($staledir)){
      if(!mkdir($staledir, 0777)){
        $message = "Unable to complete Global Translator initialization. Please manually create and make readable and writeable the following directory:
        <ul><li>".$cachedir."</li></ul>";
      }
    } else if (!is_readable($staledir) || !is_writable($staledir) ){
      $message = "Unable to complete Global Translator initialization. Please make readable and writeable the following directory:
      <ul><li>".$staledir."</li></ul>";
    }
  }
 }
}
/*Get options for form fields*/
$gltr_current_engine = $gltr_available_engines[$gltr_my_translation_engine];
$gltr_lang_matrix = $gltr_current_engine->get_languages_matrix();

/**
 * Build Java for working out languages
 * @since 0.9
 */
function gltr_build_js_function($base_lang, $selected_item) {
	global $gltr_current_engine;
	global $gltr_lang_matrix;
?>  
<script type="text/javascript">
calculateOptions('<?php echo $base_lang ?>', <?php echo $selected_item ?>);

function languageItem(lang, flags_num){
  this.lang=lang;
  this.flags_num=flags_num;
}

function calculateOptions(lang, selectedItem) {
  var flags_num = 0;
  var list = new Array();
<?php  
  $j=0;
  foreach($gltr_lang_matrix as $key => $value){
    echo "  list[$j] = new languageItem('$key', " . count($gltr_lang_matrix[$key]) . ");\n";
    $j++;
  }
?>  
  for (z = 0; z < document.forms['form1'].gltr_col_num.options.length; z++) {
    document.forms['form1'].gltr_col_num.options[z] = null;
  }
  document.forms['form1'].gltr_col_num.options.length = 0;
  
  for (y = 0; y < list.length; y++) {
    if (list[y].lang == lang){
      flags_num = list[y].flags_num;
      break;
    }
  }
  for (i = 0; i < flags_num; i++) {
    if (i == 0) {
      opt_text='all the flags in a single row (default)';
    } else if (i == 1) {
      opt_text='1 flag for each row';
    } else {
      opt_text= i + ' flags for each row';
    }
    
    if (i == 0)
    	document.forms['form1'].gltr_col_num.options[i]=new Option(opt_text, flags_num);
    else
    document.forms['form1'].gltr_col_num.options[i]=new Option(opt_text, i);
  }
  
  //I need to cycle again on the options list in order to correctly choose the selected item
  for (i = 0; i < flags_num; i++) {
    document.forms['form1'].gltr_col_num.options[i].selected = (selectedItem == i);
  }
}

function calculateAvailableTranslations(lang, selectedItem) {
  var list = new Array();
<?php  
  $j=0;
  foreach($gltr_lang_matrix as $key => $value){
    echo "  list[$j] = new languageItem('$key', " . count($gltr_lang_matrix[$key]) . ");\n";
    $j++;
  }
?>  
  for (z = 0; z < document.forms['form1'].gltr_col_num.options.length; z++) {
    document.forms['form1'].gltr_col_num.options[z] = null;
  }
  document.forms['form1'].gltr_col_num.options.length = 0;
  
  for (y = 0; y < list.length; y++) {
    if (list[y].lang == lang){
      flags_num = list[y].flags_num;
      break;
    }
  }
  for (i = 0; i <= flags_num; i++) {
    if (i == 0) {
      opt_text='all the flags in a single row (default)';
    } else if (i == 1) {
      opt_text='1 flag for each row';
    } else {
      opt_text= i + ' flags for each row';
    }
    document.forms['form1'].gltr_col_num.options[i]=new Option(opt_text, i);
  }
  
  //I need to cycle again on the options list in order to correctly choose the selected item
  for (i = 0; i <= flags_num; i++) {
    document.forms['form1'].gltr_col_num.options[i].selected = (selectedItem == i);
  }
}
</script>
<?php
}

/**
 * Displays Form
 * @since 0.9
 */
?>
<script type="text/javascript">
<!--
    function toggleVisibility(id) {
       var e = document.getElementById(id);
       if(e.style.display == 'block')
          e.style.display = 'none';
       else
          e.style.display = 'block';
    }
//-->
</script>

<!-- Start Options HTML -->
			
<div class="wrap" style="width:800px;">
  <div style="border: 1px solid rgb(221, 221, 221); padding: 5px; float: right; background-color: white; margin: 15px 15px 0;">
    
    <!-- Donations Section -->
    <div style="width: 250px; height: 100px;float:left;">
	     <h3 style="margin:3px;">Donate</h3>
        <em>If you like this plugin and find it useful, help keep this plugin free and actively developed by clicking the <a target="_blank" href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&amp;business=donations%40benosullivan%2eco%2euk&amp;lc=GB&amp;currency_code=GBP&amp;bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHosted"><strong>donate</strong></a> button.</em>
    </div>
	  <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&amp;business=donations%40benosullivan%2eco%2euk&amp;lc=GB&amp;currency_code=GBP&amp;bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHosted" title="Donate" target="_blank">
      <img style="float:right;margin-top:25px;" alt="Donate with Paypal" src="<?php echo WP_PLUGIN_URL; ?>/bens-translator/images/donate.png" />	
    </a>
  </div>
  
  <!-- Header -->
  
  <h2 style="width:300px;">Bens Translator <?php echo $btr_version_number; ?></h2>
  <?php
  //Print out the message to the user, if any
  if($message!="") {
    echo "<div class=\"updated\" style=\"width:200px;\"><p><b>";
    echo $message;
    echo "</b></p></div>";
  } 
  //Check if Global Translator is Installed
  if(btr_gltr_plugin_detected() == TRUE) {
    echo "<div class=\"error\" style=\"width:200px;\"><p><b>";
    echo "Global Translator is installed. This can cause problems.";
    echo "</b></p></div>";
  } 
  
  /**
 * Checks to see if PHP and Wordpress Minimum supported
 * @since 0.9
 */
  if (btr_check_php_version() == FALSE){  
    echo "<div class=\"error\" style=\"width:200px;\"><p><b>";
    echo "Your PHP version is not supported, Please use PHP 5 and above.";
    echo "</b></p></div>";
  }

  if (btr_check_wordpress_version() == FALSE){
    echo "<div class=\"error\" style=\"width:200px;\"><p><b>";
    echo "Your Wordpress version is not supported, Please use 2.8 and above.";
    echo "</b></p></div>";
  }

  function btr_check_php_version(){
    return version_compare(PHP_VERSION, '5.0.0', '>');
  }

  function btr_check_wordpress_version(){
    global $wp_version;
    $minimum_wp = '2.8';
    return version_compare($wp_version, $minimum_wp, '>=');
  }
  ?>
  
  <!-- Start Form -->
  
  <form id="gltr_form" name="form1" method="post" action="<?php echo $location ?>">
  	<input type="hidden" name="stage" value="process" />
    <input type="hidden" name="gltr_stats" value="<?php echo(($showstats==true)?"show":"hide");?>" />
    <input type="hidden" onclick="document.forms['form1'].stage.value='change';document.forms['form1'].submit();" 
        name="gltr_my_translation_engine" value="google" />
  <div style="width:800px;height:50px;">      
  </div>
  
  <!-- Display Flags Settings Section -->
    
  <div style="float:left;width:300px;" >
    <div style="float:left">
  		<h3><?php _e('Base settings') ?></h3>
  		  <fieldset class="options">
    		<label><?php _e('My Blog is written in:') ?>
            <select name="gltr_base_lang" onchange="document.forms['form1'].stage.value='change';document.forms['form1'].submit();">
              <?php    
              $languages = $gltr_current_engine->get_available_languages();
              foreach($languages as $key => $value){
                if ($gltr_base_lang == $key) {
              ?>
              <option value="<?php echo $key ?>" selected="selected" ><?php echo $value ?></option>
              <?php
                } else {
              ?>
              <option value="<?php echo $key ?>"  ><?php echo $value ?></option>
              <?php
                }
              }
              ?>
            </select>
          </label>
          </fieldset>
      </div>
      <div style="float:left;width:800px;margin:20px 0 20px;">
        <p style="padding:5px;"><?php _e('Choose which translations you want to make available for your visitors:') ?></p>
          <div style="float:left">
            <fieldset>
            <?php    
              foreach($gltr_lang_matrix as $key => $langs){
                if ($gltr_base_lang == $key) {
                	$i = 0;
                	foreach($langs as $lang_key => $lang_value){
                		if ($gltr_base_lang == $lang_key) continue;
                		$chk_val = "";
                		if (count ($gltr_preferred_languages) == 0 || in_array($lang_key, $gltr_preferred_languages) ) 
                			$chk_val = "checked=\"checked\"";
                		echo '<div style="float:left;width:175px;" ><input type="checkbox" name="gltr_preferred_languages[' . $i . ']" ' . $chk_val . ' value="' . $lang_key . '" />
                		<img src="' . gltr_get_flag_image($lang_key) . '" alt="$lang_key" />' . $lang_value . '</div>';
                		$i++;
                	}
                }
              }
              ?>
              </fieldset>
            </div>
        </div>
  </div>

  <!-- Options Display Section -->

  <div style="float:left;width:800px;margin:20px 0 20px;">
  	<fieldset class="options">
  		<h3>Settings</h3>
  		  <table width="100%" cellpadding="5" class="editform">
  		    <tr>
  		      <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">
  		        <a onclick="toggleVisibility('ben_trans_request_tip');" title="Click for Help!" style="cursor: pointer;">
                Time between translation requests
              </a>
            </th>
            <td>
	        	  <input size="4"  maxlength="5" name="gltr_conn_interval" type="text" id="gltr_conn_interval" value="<?php echo($gltr_conn_interval);?>"/> 
              <div id="ben_trans_request_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                (This setting stops you getting banned from google translate default is 580, Time is in seconds)
              </div>
            </td>
          </tr>
          
          
          <tr>
  		      <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">
	        	  <?php if (function_exists('gzcompress')){?>                  
                <a onclick="toggleVisibility('ben_trans_compress_tip');" title="Click for Help!" style="cursor: pointer;">
                  Enable cache compression
                </a>
            </th>
            <td>
                <input name="gltr_compress_cache" type="checkbox" id="gltr_compress_cache" <?php if($gltr_compress_cache == TRUE) {?> checked="checked" <?php } ?> /> 
                <div id="ben_trans_compress_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                  (this will strongly decrease the disk space but could give some problems on certain hosts). Disable this for plain text cache files.
                </div>
            </td>
          </tr>
          
          
          <tr>
            <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">  
						  <a onclick="toggleVisibility('ben_trans_schedule_tip');" title="Click for Help!" style="cursor: pointer;">
                  Schedule Cached pages for update after
              </a>
						</th>
						<td>            
              <input size="4"  maxlength="5" name="gltr_cache_expire_time" type="text" id="gltr_cache_expire_time" value="<?php echo($gltr_cache_expire_time);?>"/> 
              day(s)
              <div id="ben_trans_schedule_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                (This allows cached pages to expire and to be re-cached, "0" means "never")
              </div> 
            </td>
            <?php } else {?>
            <td>
              <input name="gltr_compress_cache" disabled="true" type="checkbox" id="gltr_compress_cache"/> Unable to provide cache compression feature: ZLIB not available on you php installation.</label>
            </td>
            <?php }?>
          </tr>
          
          
          <tr>
  		      <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">  
              <a onclick="toggleVisibility('ben_trans_spider_tip');" title="Click for Help!" style="cursor: pointer;">
                Block "bad" web spiders and crawlers
              </a>
            </th>
            <td>
              <input name="gltr_ban_prevention" type="checkbox" id="gltr_ban_prevention" <?php if($gltr_ban_prevention == TRUE) {?> checked="checked" <?php } ?> />   
              <div id="ben_trans_spider_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                (This will check the header of the spider and will block many "bad" spiders from hammering your cache)
              </div>
            </td>
          </tr>
          
          
          <tr>
            <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">
              <?php if (gltr_sitemap_plugin_detected()) { ?>
              <a onclick="toggleVisibility('ben_trans_sitemap_tip');" title="Click for Help!" style="cursor: pointer;">
                Enable sitemap integration
              </a>
            </th>
            <td> 
              <input name="gltr_sitemap_integration" type="checkbox" id="gltr_sitemap_integration" <?php if($gltr_sitemap_integration == TRUE) {?> checked="checked" <?php } ?> />                 
              <div id="ben_trans_sitemap_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                (This will add all your pages to your sitemap. I recommend not enabling this untill your cache is fully built)
              </div>
              <?php
                } else {?>
                    Enable sitemap integration
                </th>
                <td>         
                  "Google XML Sitemaps Generator" Not installed<br />
        	       Please download, install and activate the "<a target="_blank" href="http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/">Google XML Sitemaps Generator for WordPress 3.*</a>" in order to enable this feature.
              <?php } ?>
              </td>
            </tr>
            
            
            <tr>
              <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">               
                <a onclick="toggleVisibility('ben_trans_debug_tip');" title="Click for Help!" style="cursor: pointer;">
                  Enable Debug
                </a>
              </th>
              <td>
                <input name="gltr_enable_debug" type="checkbox" id="gltr_enable_debug" <?php if($gltr_enable_debug == TRUE) {?> checked="checked" <?php } ?> /> 
                <div id="ben_trans_debug_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                  <strong>"debug.log"</strong> file, which will be saved in the following directory:<br />
	        	      <strong><?php echo(dirname(__file__));?></strong>.<br />
                </div>   
              </td>
            </tr>
            
            
            <tr>
              <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">    
                <a onclick="toggleVisibility('ben_trans_table_tip');" title="Click for Help!" style="cursor: pointer;">      
                  Enclose the flags(links) inside a
                </a>
              </th>
              <td>
                <label>
                  TABLE
                  <input type="radio" <?php if($gltr_html_bar_tag == 'TABLE') {?> checked="checked" <?php } ?> name="gltr_html_bar_tag" value="TABLE" />
                </label>
                <label>
                  DIV
                  <input type="radio" <?php if($gltr_html_bar_tag == 'DIV') {?> checked="checked" <?php } ?> name="gltr_html_bar_tag" value="DIV" />
                </label>
                <div id="ben_trans_table_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                  Changes the encapsulation code you want to use for your flag bar. This wil allow for validation and CSS.
                </div>
              </td>
            </tr>
        
        
            <tr>
              <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">    
                <a onclick="toggleVisibility('ben_trans_table_tip_flag');" title="Click for Help!" style="cursor: pointer;">      
                  Show language links as
                </a>
              </th>
              <td>
                <label>
                  Text
                  <input type="radio" <?php if($gltr_html_bar_tag_flag == 'TEXT') {?> checked="checked" <?php } ?> name="gltr_html_bar_tag_flag" value="TEXT" />
                </label>
                <label>
                  Flags
                  <input type="radio" <?php if($gltr_html_bar_tag_flag == 'FLAG') {?> checked="checked" <?php } ?> name="gltr_html_bar_tag_flag" value="FLAG" />
                </label>
                <div id="ben_trans_table_tip_flag" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                  Chooses whether you want the links in the translation bar to be plain text or flags
                </div>
              </td>
            </tr>
            
            <tr>
              <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">
                <a onclick="toggleVisibility('ben_trans_table_row_tip');" title="Click for Help!" style="cursor: pointer;">      
                  Show how many flags per row (table)
                </a>
              </th>
              <td>
                <select name="gltr_col_num"></select>
                <div id="ben_trans_table_row_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                  This changes how many flags are shown per line TABLE only. For DIVs you need to CSS it.
                </div>
              </td>
            </tr>               
           
           
            <tr>
              <th style="text-align: right; vertical-align: top;width:320px;padding:10px;" scope="row">               
                <a onclick="toggleVisibility('ben_trans_translate_template_tip');" title="Click for Help!" style="cursor: pointer;">
                  Enable Translation Visitor Warning
                </a>
              </th>
              <td>
                <input name="btr_translate_template" type="checkbox" id="btr_translate_template" <?php if($btr_translate_template == TRUE) {?> checked="checked" <?php } ?> /> 
                <div id="ben_trans_translate_template_tip" style="max-width: 600px; text-align: left; display: none; margin:5px;">
                  This enables a warning bar to be displayed to visitors showing them that the page is translated
                </div>   
              </td>
            </tr>
             
      
          </table>
      </fieldset>
  </div>
  
  <!-- Start Cache Information Section -->
  
  <div style="float:left;width:800px;margin:20px 0 20px;">
    <?php 
    /**
      * Loads Cache Information
      * @since 0.9
      */
    gltr_init_info(); 
    ?>
      <?php 
        $count_posts = wp_count_posts(); 
        $published_posts = $count_posts->publish;
        $total_languages = count ($gltr_preferred_languages);
        $total_translate = $published_posts * $total_languages;
        $total_pages = $total_translate;
      ?>
	    <h3>Statistics</h3>
	      <ul>
          <li>Estimated total of pages to translate:<strong><?php echo ($total_pages);?></strong></li>
	        <li>Your cache directory currently contains <strong><?php echo($gltr_cached_files_num)?></strong> successfully translated and cached pages.</li>
	        <li><strong>Cache directory size</strong>: <?php $size=round($gltr_cache_size/1024/1024,1); echo ($size);?> MB</li>
	        <li>Your stale directory currently contains <strong><?php echo($gltr_stale_files_num)?></strong> successfully translated and cached pages waiting for a new translation.</li>
	        <li><strong>Stale directory size</strong>: <?php $size=round($gltr_stale_size/1024/1024,1); echo ($size);?> MB</li>
	      </ul>
	      <ul style="margin-top:30px;">
						<?php
	        	//$diff_time = gltr_get_last_cached_file_time();
						if ($diff_time > 0){
		        	echo ("<li>Latest allowed connection to the translation engine: <strong>");
	    	      if ($diff_time < 60){
				      	echo (round(($diff_time)) . " second(s) ago</strong>");
	      			}
              else if ($diff_time > 60*60){
	      				echo (round(($diff_time)/3600) . " hour(s) ago</strong>");    
		      		}
              else{
		      			echo (round(($diff_time)/60) . " minute(s) ago</strong>");
		      		}
		      		global $gltr_last_cached_url;
		      		if (strlen($gltr_last_cached_url)>0){
		      			echo (". [<a target='_blank' href='$gltr_last_cached_url'>See latest translated page</a>]");
		      		}
						} 
            else {
							echo ("<li>Latest allowed connection to the translation engine: <strong>not available</strong>");
						}
						echo ("</li>");
						echo ("<li><strong>Translations status</strong>:");	
						$ban_status = get_option("gltr_translation_status");					
						if ($ban_status == 'banned'){
							echo("<strong><font color='red'>Bad or unhandled response from the '".strtoupper(get_option('gltr_my_translation_engine'))."' translation engine.</font></strong> This could mean that:
							<ul><li>Your blog has been temporarily banned: increase the time interval between the translation requests and wait for some days or switch to another translation engine</li>
							<li>The translation engine is currently not responding/working: wait for some days or switch to another translation engine</li>
							<li>The translation engine has changed something (i.e. the translation url): wait for the next release of Global Translator :-)</li>
							<li>You haven't added the flags widget on your pages: adding the flags bar is mandatory in order to make Global Translator able to work correctly</li></font>");
						} else if ($ban_status == 'working'){
							echo("<strong><font color='green'>Working properly</font></strong>");
						} else {
							echo("<strong>not available</strong>");
						}
						echo ("</li>");
	        	?>
	        </ul>
	  </div>
	  
	  <!-- Submit Form Button Section -->
    
    <div style="float:left;width:800px;margin:20px 0 20px;">
      <p class="submit">
        <input type="submit" name="gltr_save" value="<?php _e('Update options') ?> &raquo;" />
      </p>
    </div>
    
  </form>
</div>
<?php
if (!is_numeric($gltr_col_num))$gltr_col_num = 0;
gltr_build_js_function($gltr_base_lang, $gltr_col_num);
?>