<?php
/*
Plugin Name: Bens Translator
Plugin URI: http://benosullivan.co.uk/bens-translator/
Description: Automatically translates a blog in 19 different languages supported by analytics using the Google Translation Engine. After uploading this plugin click 'Activate' (to the right) and then afterwards you must <a href="options-general.php?page=bens-translator/core/options-translator.php">visit the options page</a>.
Version: 1.2
Author: Ben O'Sullivan
Author URI: http://benosullivan.co.uk/
Disclaimer: Use at your own risk. No warranty expressed or implied is provided. The author will never be liable for any loss of profit, physical or psychical damage, legal problems. The author disclaims any responsibility for any action of final users. It is the final user's responsibility to obey all applicable local, state, and federal laws.

*/

/*  Copyright 2009  Ben O'Sullivan (email : contact@benosullivan.co.uk)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
 * Sets hook for Activation and Deactivation of plugin
 * @since 0.9
 */
register_activation_hook(__FILE__, 'btr_activation');
register_deactivation_hook(__FILE__, 'btr_deactivation');

/**
 * Removes any options that remain during activation
 * @since 0.9
 */
function btr_activation(){
  gltr_debug("btr_plugin_activate :: plugin activation");
        update_option('gltr_base_lang', 'en');
	      update_option('gltr_col_num', '7' );
	      update_option('gltr_html_bar_tag','TABLE' );
	      update_option('gltr_my_translation_engine','google' );
	      update_option('gltr_preferred_languages', array());
				update_option("gltr_last_connection_time",'');
				update_option("gltr_translation_status", 'unknown');
	      update_option('gltr_conn_interval', '580');
	      update_option('gltr_cache_expire_time', '30');
	      update_option('gltr_ban_prevention', true);
	      update_option('gltr_sitemap_integration', false);
	      update_option('gltr_compress_cache', true);
	      update_option('gltr_enable_debug', false);
	      update_option('btr_translate_template', true);
	      update_option('gltr_html_bar_tag_flag','FLAG' );
}

/**
 * Removes all options in DB on deactivation
 * @since 0.9
 */
function btr_deactivation() {
  gltr_debug("btr_plugin_activate :: plugin deactivation");
        delete_option('gltr_base_lang');
	      delete_option('gltr_col_num');
	      delete_option('gltr_html_bar_tag');
	      delete_option('gltr_my_translation_engine');
	      delete_option('gltr_preferred_languages');
				delete_option("gltr_last_connection_time");
				delete_option("gltr_translation_status");
	      delete_option('gltr_conn_interval');
	      delete_option('gltr_cache_expire_time');
	      delete_option('gltr_ban_prevention');
	      delete_option('gltr_sitemap_integration');
	      delete_option('gltr_compress_cache');
	      delete_option('gltr_enable_debug');
	      delete_option('btr_translate_template');
	      delete_option('gltr_html_bar_tag_flag');
}

// Create Cache Folder, Recreate if missing
	$gltr_cache_dir = WP_CONTENT_DIR . "/ben-translate-cache";
  IF (!file_exists($gltr_cache_dir)){
    mkdir($gltr_cache_dir);
  }

// Check if IMG Setting is wrong
  $gltr_html_bar_tag = get_option('gltr_html_bar_tag');
  IF ($gltr_html_bar_tag == 'MAP'){
    update_option('gltr_html_bar_tag', 'TABLE');
  }

$gltr_result = '';


if (SITEMAP_INTEGRATION) add_action("sm_buildmap","gltr_add_translated_pages_to_sitemap");
add_action('plugins_loaded', 'widget_global_translator_init');

// Include Required Files 
require_once (dirname(__file__).'/core/settings.php');
require_once (dirname(__file__).'/core/functions.php');
//require_once (dirname(__file__).'/core/cron.php');

$gltr_engine = $gltr_available_engines[TRANSLATION_ENGINE];
?>